// JTNoConfirmDial.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"
#include "JTPlugin.h"
#include "NCDApp.h"

/* Global Variables */
CNCDApp*	g_pApp = NULL;


BOOL
APIENTRY
DllMain(
	HANDLE hModule, 
	DWORD  ul_reason_for_call, 
	LPVOID lpReserved
)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		break;
	case DLL_PROCESS_DETACH:
		if (g_pApp != NULL) {
			g_pApp->Stop();
			g_pApp->Terminate();
			delete g_pApp;
			g_pApp = NULL;
		}
		break;
	}
    return TRUE;
}


DLLEXPORT
DWORD
JTEvent_PermitSpecVersion()
{
	return MAKEVERSION(MAJOR, MINOR, BUILD, REVISION);
}


DLLEXPORT
BOOL
JTEvent_Init(
	 HMODULE hJoeTune
)
{
	BOOL		bRet;
	CNCDApp*	pApp = NULL;

	bRet = FALSE;

	if (g_pApp == NULL) {
		pApp = new CNCDApp();
		if (pApp != NULL) {
			if (pApp->Initialize()) {
				if (pApp->Start()) {
					g_pApp = pApp;
					bRet = TRUE;
				}
				else {
					pApp->Terminate();
					delete pApp;
					pApp = NULL;
				}
			}
			else {
				delete pApp;
				pApp = NULL;
			}
		}
	}

	return bRet;
}


DLLEXPORT
void
JTEvent_Close()
{
	if (g_pApp != NULL) {
		g_pApp->Stop();
		g_pApp->Terminate();
		delete g_pApp;
		g_pApp = NULL;
	}
}

